# Elder Research customizations of GitLab's Maven template:
# https://gitlab.com/gitlab-org/gitlab/blob/master/lib/gitlab/ci/templates/Maven.gitlab-ci.yml

variables:
  # This will suppress any download for dependencies and plugins or upload messages which would clutter the console log.
  # `showDateTime` will show the passed time in milliseconds. You need to specify `--batch-mode` to make this work.
  MAVEN_OPTS: "-Dhttps.protocols=TLSv1.2 -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository -Dorg.slf4j.simpleLogger.log.org.apache.maven.cli.transfer.Slf4jMavenTransferListener=WARN -Dorg.slf4j.simpleLogger.showDateTime=true -Djava.awt.headless=true"
  # As of Maven 3.3.0 instead of this you may define these options in `.mvn/maven.config` so the same config is used
  # when running from the command line.
  # `installAtEnd` and `deployAtEnd` are only effective with recent version of the corresponding plugins.
  MAVEN_CLI_OPTS: "--batch-mode --errors --fail-at-end --show-version -DinstallAtEnd=true -DdeployAtEnd=true -s settings.xml"

# This template uses jdk11 for verifying and deploying images
# ERI: Use Coretto as the ERI recommended open JDK build
image: maven:3-amazoncorretto-11

# Cache downloaded dependencies and plugins between builds.
# To keep cache across branches add 'key: "$CI_JOB_NAME"'
cache:
  paths:
    - .m2/repository

stages:
  - Build and Push

build-and-push:
  stage: Build and Push
  script:
    - echo '<settings xmlns="http://maven.apache.org/SETTINGS/1.1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xsi:schemaLocation="http://maven.apache.org/SETTINGS/1.1.0 http://maven.apache.org/xsd/settings-1.1.0.xsd"> <servers> <server> <id>gitlab-maven</id> <configuration> <httpHeaders> <property> <name>Job-Token</name> <value>${CI_JOB_TOKEN}</value> </property> </httpHeaders> </configuration> </server> </servers> <profiles> <profile> <id>ci-profile</id> <repositories> <repository> <releases> <enabled>true</enabled> </releases> <snapshots> <enabled>true</enabled> </snapshots> <id>gitlab-maven</id> <url>https://gitlab.com/api/v4/groups/5395358/-/packages/maven</url> </repository> </repositories> <pluginRepositories> <pluginRepository> <releases> <enabled>true</enabled> </releases> <snapshots> <enabled>true</enabled> </snapshots> <id>gitlab-maven</id> <url>https://gitlab.com/api/v4/groups/5395358/-/packages/maven</url> </pluginRepository> </pluginRepositories> </profile> </profiles> <activeProfiles> <activeProfile>ci-profile</activeProfile> </activeProfiles> </settings>' > settings.xml
    - 'mvn $MAVEN_CLI_OPTS deploy'
  only:
    - main